from ngsolve import *
import netgen.gui
from netgen.geom2d import unit_square



uref = CoefficientFunction(x*x)

mesh = Mesh(unit_square.GenerateMesh(maxh=0.1))

V = L2(mesh, order=1)
u = V.TrialFunction()
v = V.TestFunction()
L = LinearForm(V)
L += uref * v * dx
a = BilinearForm(V, symmetric=True)
a += u*v*dx
Puref = GridFunction(V)
a.Assemble()
L.Assemble()
Puref.vec.data = a.mat.Inverse(V.FreeDofs(), inverse='sparsecholesky') * L.vec
print(Integrate((uref-Puref)*Puref, mesh))

